CachingParserPool.SynchronizedGrammarPool (Xerces2 Implementation)
Date: 2016-02-03

org.apache.xerces.parsers

## Class CachingParserPool.SynchronizedGrammarPool

- java.lang.Object
- - org.apache.xerces.parsers.CachingParserPool.SynchronizedGrammarPool

- All Implemented Interfaces:
    org.apache.xerces.xni.grammars.XMLGrammarPool
  Enclosing class:
    CachingParserPool

      public static final class CachingParserPool.SynchronizedGrammarPool
      extends java.lang.Object
      implements org.apache.xerces.xni.grammars.XMLGrammarPool

  Synchronized grammar pool.
  Author:
    Andy Clark, IBM

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `CachingParserPool.SynchronizedGrammarPool(org.apache.xerces.xni.grammars.XMLGrammarPool grammarPool)` Constructs a synchronized grammar pool.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `cacheGrammars(java.lang.String grammarType, org.apache.xerces.xni.grammars.Grammar[] grammars)` return the final set of grammars that the validator ended up with.
    `void` | `clear()` clear the grammar pool
    `void` | `lockPool()` lock the grammar pool
    `org.apache.xerces.xni.grammars.Grammar` | `retrieveGrammar(org.apache.xerces.xni.grammars.XMLGrammarDescription gDesc)` This method requests that the application retrieve a grammar corresponding to the given GrammarIdentifier from its cache.
    `org.apache.xerces.xni.grammars.Grammar[]` | `retrieveInitialGrammarSet(java.lang.String grammarType)` retrieve the initial known set of grammars.
    `void` | `unlockPool()` unlock the grammar pool

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### CachingParserPool.SynchronizedGrammarPool

          public CachingParserPool.SynchronizedGrammarPool(org.apache.xerces.xni.grammars.XMLGrammarPool grammarPool)

      Constructs a synchronized grammar pool.

  - ### Method Detail

    - #### retrieveInitialGrammarSet

          public org.apache.xerces.xni.grammars.Grammar[] retrieveInitialGrammarSet(java.lang.String grammarType)

      Description copied from interface: `org.apache.xerces.xni.grammars.XMLGrammarPool`

      retrieve the initial known set of grammars. this method is called by a validator before the validation starts. the application can provide an initial set of grammars available to the current validation attempt.

      Specified by:
        `retrieveInitialGrammarSet` in interface `org.apache.xerces.xni.grammars.XMLGrammarPool`
      Parameters:
        `grammarType` - the type of the grammar, from the `org.apache.xerces.xni.grammars.Grammar` interface.
      Returns:
        the set of grammars the validator may put in its "bucket"

    - #### retrieveGrammar

          public org.apache.xerces.xni.grammars.Grammar retrieveGrammar(org.apache.xerces.xni.grammars.XMLGrammarDescription gDesc)

      Description copied from interface: `org.apache.xerces.xni.grammars.XMLGrammarPool`

      This method requests that the application retrieve a grammar corresponding to the given GrammarIdentifier from its cache. If it cannot do so it must return null; the parser will then call the EntityResolver. An application must not call its EntityResolver itself from this method; this may result in infinite recursions.

      Specified by:
        `retrieveGrammar` in interface `org.apache.xerces.xni.grammars.XMLGrammarPool`
      Parameters:
        `gDesc` - The description of the Grammar being requested.
      Returns:
        the Grammar corresponding to this description or null if no such Grammar is known.

    - #### cacheGrammars

          public void cacheGrammars(java.lang.String grammarType,
                           org.apache.xerces.xni.grammars.Grammar[] grammars)

      Description copied from interface: `org.apache.xerces.xni.grammars.XMLGrammarPool`

      return the final set of grammars that the validator ended up with. This method is called after the validation finishes. The application may then choose to cache some of the returned grammars.

      Specified by:
        `cacheGrammars` in interface `org.apache.xerces.xni.grammars.XMLGrammarPool`
      Parameters:
        `grammarType` - the type of the grammars being returned;
        `grammars` - an array containing the set of grammars being returned; order is not significant.

    - #### lockPool

          public void lockPool()

      lock the grammar pool
      Specified by:
        `lockPool` in interface `org.apache.xerces.xni.grammars.XMLGrammarPool`

    - #### clear

          public void clear()

      clear the grammar pool
      Specified by:
        `clear` in interface `org.apache.xerces.xni.grammars.XMLGrammarPool`

    - #### unlockPool

          public void unlockPool()

      unlock the grammar pool
      Specified by:
        `unlockPool` in interface `org.apache.xerces.xni.grammars.XMLGrammarPool`

Copyright © 1999-2010 The Apache Software Foundation. All Rights Reserved.